(function (console, $global) { "use strict";
function $extend(from, fields) {
	function Inherit() {} Inherit.prototype = from; var proto = new Inherit();
	for (var name in fields) proto[name] = fields[name];
	if( fields.toString !== Object.prototype.toString ) proto.toString = fields.toString;
	return proto;
}
var HxOverrides = function() { };
HxOverrides.__name__ = ["HxOverrides"];
HxOverrides.substr = function(s,pos,len) {
	if(pos != null && pos != 0 && len != null && len < 0) return "";
	if(len == null) len = s.length;
	if(pos < 0) {
		pos = s.length + pos;
		if(pos < 0) pos = 0;
	} else if(len < 0) len = s.length + len - pos;
	return s.substr(pos,len);
};
Math.__name__ = ["Math"];
var Std = function() { };
Std.__name__ = ["Std"];
Std.string = function(s) {
	return js_Boot.__string_rec(s,"");
};
var Type = function() { };
Type.__name__ = ["Type"];
Type.getClassName = function(c) {
	var a = c.__name__;
	if(a == null) return null;
	return a.join(".");
};
var haxe_IMap = function() { };
haxe_IMap.__name__ = ["haxe","IMap"];
var haxe_ds__$StringMap_StringMapIterator = function(map,keys) {
	this.map = map;
	this.keys = keys;
	this.index = 0;
	this.count = keys.length;
};
haxe_ds__$StringMap_StringMapIterator.__name__ = ["haxe","ds","_StringMap","StringMapIterator"];
haxe_ds__$StringMap_StringMapIterator.prototype = {
	hasNext: function() {
		return this.index < this.count;
	}
	,next: function() {
		return this.map.get(this.keys[this.index++]);
	}
	,__class__: haxe_ds__$StringMap_StringMapIterator
};
var haxe_ds_StringMap = function() {
	this.h = { };
};
haxe_ds_StringMap.__name__ = ["haxe","ds","StringMap"];
haxe_ds_StringMap.__interfaces__ = [haxe_IMap];
haxe_ds_StringMap.prototype = {
	set: function(key,value) {
		if(__map_reserved[key] != null) this.setReserved(key,value); else this.h[key] = value;
	}
	,get: function(key) {
		if(__map_reserved[key] != null) return this.getReserved(key);
		return this.h[key];
	}
	,setReserved: function(key,value) {
		if(this.rh == null) this.rh = { };
		this.rh["$" + key] = value;
	}
	,getReserved: function(key) {
		if(this.rh == null) return null; else return this.rh["$" + key];
	}
	,remove: function(key) {
		if(__map_reserved[key] != null) {
			key = "$" + key;
			if(this.rh == null || !this.rh.hasOwnProperty(key)) return false;
			delete(this.rh[key]);
			return true;
		} else {
			if(!this.h.hasOwnProperty(key)) return false;
			delete(this.h[key]);
			return true;
		}
	}
	,arrayKeys: function() {
		var out = [];
		for( var key in this.h ) {
		if(this.h.hasOwnProperty(key)) out.push(key);
		}
		if(this.rh != null) {
			for( var key in this.rh ) {
			if(key.charCodeAt(0) == 36) out.push(key.substr(1));
			}
		}
		return out;
	}
	,iterator: function() {
		return new haxe_ds__$StringMap_StringMapIterator(this,this.arrayKeys());
	}
	,__class__: haxe_ds_StringMap
};
var js_Boot = function() { };
js_Boot.__name__ = ["js","Boot"];
js_Boot.getClass = function(o) {
	if((o instanceof Array) && o.__enum__ == null) return Array; else {
		var cl = o.__class__;
		if(cl != null) return cl;
		var name = js_Boot.__nativeClassName(o);
		if(name != null) return js_Boot.__resolveNativeClass(name);
		return null;
	}
};
js_Boot.__string_rec = function(o,s) {
	if(o == null) return "null";
	if(s.length >= 5) return "<...>";
	var t = typeof(o);
	if(t == "function" && (o.__name__ || o.__ename__)) t = "object";
	switch(t) {
	case "object":
		if(o instanceof Array) {
			if(o.__enum__) {
				if(o.length == 2) return o[0];
				var str2 = o[0] + "(";
				s += "\t";
				var _g1 = 2;
				var _g = o.length;
				while(_g1 < _g) {
					var i1 = _g1++;
					if(i1 != 2) str2 += "," + js_Boot.__string_rec(o[i1],s); else str2 += js_Boot.__string_rec(o[i1],s);
				}
				return str2 + ")";
			}
			var l = o.length;
			var i;
			var str1 = "[";
			s += "\t";
			var _g2 = 0;
			while(_g2 < l) {
				var i2 = _g2++;
				str1 += (i2 > 0?",":"") + js_Boot.__string_rec(o[i2],s);
			}
			str1 += "]";
			return str1;
		}
		var tostr;
		try {
			tostr = o.toString;
		} catch( e ) {
			return "???";
		}
		if(tostr != null && tostr != Object.toString && typeof(tostr) == "function") {
			var s2 = o.toString();
			if(s2 != "[object Object]") return s2;
		}
		var k = null;
		var str = "{\n";
		s += "\t";
		var hasp = o.hasOwnProperty != null;
		for( var k in o ) {
		if(hasp && !o.hasOwnProperty(k)) {
			continue;
		}
		if(k == "prototype" || k == "__class__" || k == "__super__" || k == "__interfaces__" || k == "__properties__") {
			continue;
		}
		if(str.length != 2) str += ", \n";
		str += s + k + " : " + js_Boot.__string_rec(o[k],s);
		}
		s = s.substring(1);
		str += "\n" + s + "}";
		return str;
	case "function":
		return "<function>";
	case "string":
		return o;
	default:
		return String(o);
	}
};
js_Boot.__interfLoop = function(cc,cl) {
	if(cc == null) return false;
	if(cc == cl) return true;
	var intf = cc.__interfaces__;
	if(intf != null) {
		var _g1 = 0;
		var _g = intf.length;
		while(_g1 < _g) {
			var i = _g1++;
			var i1 = intf[i];
			if(i1 == cl || js_Boot.__interfLoop(i1,cl)) return true;
		}
	}
	return js_Boot.__interfLoop(cc.__super__,cl);
};
js_Boot.__instanceof = function(o,cl) {
	if(cl == null) return false;
	switch(cl) {
	case Int:
		return (o|0) === o;
	case Float:
		return typeof(o) == "number";
	case Bool:
		return typeof(o) == "boolean";
	case String:
		return typeof(o) == "string";
	case Array:
		return (o instanceof Array) && o.__enum__ == null;
	case Dynamic:
		return true;
	default:
		if(o != null) {
			if(typeof(cl) == "function") {
				if(o instanceof cl) return true;
				if(js_Boot.__interfLoop(js_Boot.getClass(o),cl)) return true;
			} else if(typeof(cl) == "object" && js_Boot.__isNativeObj(cl)) {
				if(o instanceof cl) return true;
			}
		} else return false;
		if(cl == Class && o.__name__ != null) return true;
		if(cl == Enum && o.__ename__ != null) return true;
		return o.__enum__ == cl;
	}
};
js_Boot.__nativeClassName = function(o) {
	var name = js_Boot.__toStr.call(o).slice(8,-1);
	if(name == "Object" || name == "Function" || name == "Math" || name == "JSON") return null;
	return name;
};
js_Boot.__isNativeObj = function(o) {
	return js_Boot.__nativeClassName(o) != null;
};
js_Boot.__resolveNativeClass = function(name) {
	return $global[name];
};
var pbsdaniel_Constants = function() { };
pbsdaniel_Constants.__name__ = ["pbsdaniel","Constants"];
var pbsdaniel_DTLoadingScreen = function() {
	createjs.Container.call(this);
	this._bg = new createjs.Shape();
	this._bg.graphics.beginFill("#fff48b");
	this._bg.graphics.drawRect(0,0,960,500);
	this._bg.graphics.endFill();
	this.addChild(this._bg);
	this._trolley = new createjs.Container();
	this.addChild(this._trolley);
	this._assets = new sg_pbskids_AssetPackage(this.getImageManifest(),this.getAudioManifest(),$bind(this,this.onPackageReady));
	this._assets.load();
};
pbsdaniel_DTLoadingScreen.__name__ = ["pbsdaniel","DTLoadingScreen"];
pbsdaniel_DTLoadingScreen.__super__ = createjs.Container;
pbsdaniel_DTLoadingScreen.prototype = $extend(createjs.Container.prototype,{
	start: function() {
		this._trolley.scaleX = .9;
		this._trolley.scaleY = 1.1;
		createjs.Tween.get(this._trolley,{ loop : true}).to({ scaleX : 1.05, scaleY : .95},400,createjs.Ease.backIn).to({ scaleX : .95, scaleY : 1.05},300,createjs.Ease.cubicInOut);
	}
	,freeze: function() {
		this._trolley.scaleX = this._trolley.scaleY = 1;
		createjs.Tween.removeTweens(this._trolley);
	}
	,onPackageReady: function() {
		var trolley = this._assets.getSpriteFromSheet("loadingTrolley","loadingScreenSheet");
		var text = this._assets.getSpriteFromSheet("loadingText","loadingScreenSheet");
		trolley.y = trolley.getBounds().height * -1;
		trolley.x = trolley.getBounds().width * -.5;
		this._trolley.addChild(trolley);
		this._trolley.x = 480.;
		this._trolley.y = 250.;
		this._text = text;
		this._text.x = (960 - text.getBounds().width) * .5;
		this._text.y = (500 - text.getBounds().height) * .55;
		this.addChild(this._text);
	}
	,getImageManifest: function() {
		var manifest = [];
		manifest.push(sg_pbskids_AssetPackage.makeManifestItem("loadingScreenSheet","assets/sheets/loading.json","spritesheet"));
		return manifest;
	}
	,getAudioManifest: function() {
		var manifest = [];
		return manifest;
	}
	,__class__: pbsdaniel_DTLoadingScreen
});
var pbsdaniel_dressup_CategoryButton = function(cfg) {
	createjs.Container.call(this);
	this.config = cfg;
	this.setTransform(this.config.position.x,this.config.position.y);
	this.atIndex = Math.floor(this.config.items.length * Math.random());
	this.active = false;
	this._sfx = this.config.sfx;
	this.addEventListener("mousedown",$bind(this,this.onMouseDown),null);
};
pbsdaniel_dressup_CategoryButton.__name__ = ["pbsdaniel","dressup","CategoryButton"];
pbsdaniel_dressup_CategoryButton.__super__ = createjs.Container;
pbsdaniel_dressup_CategoryButton.prototype = $extend(createjs.Container.prototype,{
	destroy: function() {
		createjs.Tween.removeTweens(this);
		this.removeEventListener("mousedown",$bind(this,this.onMouseDown),null);
	}
	,onMouseDown: function(e) {
		sg_pbskids_audio_SRAudioManager.instance.playAudio(this._sfx);
		createjs.Tween.get(this).to({ scaleX : 1.1, scaleY : 1.1},100,createjs.Ease.quartIn).to({ scaleX : 1, scaleY : 1},100,createjs.Ease.quartOut);
	}
	,setImage: function(sprite) {
		this._buttonImage = sprite;
		this._buttonImage.regX = this._buttonImage.getBounds().width * .5;
		this._buttonImage.regY = this._buttonImage.getBounds().height * .5;
		this.x += this._buttonImage.regX;
		this.y += this._buttonImage.regY;
		this.addChild(this._buttonImage);
	}
	,__class__: pbsdaniel_dressup_CategoryButton
});
var pbsdaniel_dressup_Curtain = function(bg) {
	createjs.Container.call(this);
	this._bg = bg;
	this.fullOpen();
	this.addChild(this._bg);
};
pbsdaniel_dressup_Curtain.__name__ = ["pbsdaniel","dressup","Curtain"];
pbsdaniel_dressup_Curtain.__super__ = createjs.Container;
pbsdaniel_dressup_Curtain.prototype = $extend(createjs.Container.prototype,{
	open: function(callback,duration) {
		if(duration == null) duration = 500;
		createjs.Tween.get(this._bg).to({ x : this._bg.getBounds().width},duration,createjs.Ease.getPowOut(3)).call(callback);
	}
	,close: function(callback,duration) {
		if(duration == null) duration = 500;
		createjs.Tween.get(this._bg).to({ x : 0},duration,createjs.Ease.getPowOut(3)).call(callback);
	}
	,fullClose: function() {
		this._bg.x = 0;
	}
	,fullOpen: function() {
		this._bg.x = this._bg.getBounds().width;
	}
	,__class__: pbsdaniel_dressup_Curtain
});
var sg_pbskids_daniel_SpringrollGame = function(springrollApp,debug) {
	if(debug == null) debug = false;
	var _g = this;
	sg_pbskids_daniel_SpringrollGame.SpringrollApp = springrollApp;
	if(springrollApp.options.debug == true) sg_springroll_logging_Logging.enabled = true; else sg_springroll_logging_Logging.enabled = false;
	this.checkEnvironment();
	sg_springroll_logging_Logging.log("New DanielGame!",sg_pbskids_daniel_SpringrollGame);
	this._stage = springrollApp.display.stage;
	this._stage.enableMouseOver(10);
	window.SRApp = springrollApp;
	this.BG = new createjs.Shape();
	this.BG.graphics.beginFill("orange").drawRect(0,0,springrollApp.display.width,springrollApp.display.height).endFill();
	this._stage.addChild(this.BG);
	this.container = new createjs.Container();
	this.container.name = "springrollGameContainer";
	this._stage.addChild(this.container);
	this._loadLayer = new createjs.Container();
	this._loadLayer.name = "loadContainer";
	this._loadLayer.mouseChildren = false;
	this._loadLayer.mouseEnabled = false;
	this._gameLayer = new createjs.Container();
	this._gameLayer.name = "gameContainer";
	this._debugLayer = new createjs.Container();
	this._debugLayer.mouseEnabled = false;
	this._debugLayer.mouseChildren = false;
	this.container.addChild(this._gameLayer);
	this.container.addChild(this._loadLayer);
	if(debug) this.container.addChild(this._debugLayer);
	createjs.Touch.enable(this._stage,true);
	springrollApp.on("update",function(delta,a,b) {
		_g.update({ delta : delta});
	});
};
sg_pbskids_daniel_SpringrollGame.__name__ = ["sg","pbskids","daniel","SpringrollGame"];
sg_pbskids_daniel_SpringrollGame.prototype = {
	checkEnvironment: function() {
		var query = window.location.search.substring(1);
		this._queryVars = query.split("&");
		var _g1 = 0;
		var _g = this._queryVars.length;
		while(_g1 < _g) {
			var i = _g1++;
			var pair = this._queryVars[i].split("=");
			if(pair[0] == "packageName" && pair[1] == "org.pbskids.gamesapp") sg_pbskids_daniel_SpringrollGame.isPBSKidsApp = true;
		}
	}
	,resize: function(e) {
		this.BG.graphics.clear();
		this.BG.graphics.beginFill("orange").drawRect(0,0,e.width,e.height).endFill();
	}
	,begin: function() {
		if(sg_pbskids_daniel_SpringrollGame.SpringrollApp.scaling != null) {
		}
	}
	,update: function(e) {
		this._stage.update(e);
	}
	,__class__: sg_pbskids_daniel_SpringrollGame
};
var pbsdaniel_dressup_DressUp = function(springrollApp,debug) {
	if(debug == null) debug = false;
	sg_pbskids_daniel_SpringrollGame.call(this,springrollApp,debug);
	this._loadingScreen = new pbsdaniel_DTLoadingScreen();
	this._loadingScreen.addEventListener("added",($_=this._loadingScreen,$bind($_,$_.start)));
	this._loadingScreen.addEventListener("removed",($_=this._loadingScreen,$bind($_,$_.freeze)));
	this._loadLayer.addChild(this._loadingScreen);
	pbsdaniel_dressup_DressUp.globalAssets = new sg_pbskids_AssetPackage(this.getGlobalData(),null,$bind(this,this.onGlobalAssetsRetrieved));
};
pbsdaniel_dressup_DressUp.__name__ = ["pbsdaniel","dressup","DressUp"];
pbsdaniel_dressup_DressUp.__super__ = sg_pbskids_daniel_SpringrollGame;
pbsdaniel_dressup_DressUp.prototype = $extend(sg_pbskids_daniel_SpringrollGame.prototype,{
	update: function(e) {
		sg_pbskids_daniel_SpringrollGame.prototype.update.call(this,e);
		dragonBones.animation.WorldClock.clock.advanceTime(e.delta / 1000);
		if(this._screen != null) this._screen.update(e);
	}
	,begin: function() {
		sg_pbskids_daniel_SpringrollGame.prototype.begin.call(this);
		pbsdaniel_dressup_DressUp.globalAssets.load();
	}
	,getGlobalData: function() {
		var manifest = [];
		manifest.push(sg_pbskids_AssetPackage.makeManifestItem("gameData","assets/data/game_data.json","json"));
		manifest.push(sg_pbskids_AssetPackage.makeManifestItem("characterData","assets/data/character_data.json","json"));
		manifest.push(sg_pbskids_AssetPackage.makeManifestItem("titlescreenData","assets/data/titlescreen_data.json","json"));
		manifest.push(sg_pbskids_AssetPackage.makeManifestItem("curtain","assets/images/curtain.jpg","image"));
		return manifest;
	}
	,onGlobalAssetsRetrieved: function() {
		pbsdaniel_dressup_DressUp.GameData = pbsdaniel_dressup_DressUp.globalAssets.getResult("gameData");
		pbsdaniel_dressup_DressUp.CharacterInfo = pbsdaniel_dressup_DressUp.globalAssets.getResult("characterData");
		pbsdaniel_dressup_DressUp.CharacterMap = new haxe_ds_StringMap();
		var _g = 0;
		var _g1 = pbsdaniel_dressup_DressUp.CharacterInfo.characters;
		while(_g < _g1.length) {
			var entry = _g1[_g];
			++_g;
			pbsdaniel_dressup_DressUp.CharacterMap.set(entry.character,entry);
		}
		this._curtain = new pbsdaniel_dressup_Curtain(pbsdaniel_dressup_DressUp.globalAssets.getBitmap("curtain"));
		this._screen = new sg_springroll_screens_TitleScreen(pbsdaniel_dressup_DressUp.globalAssets.getResult("titlescreenData"),"dressupScene",$bind(this,this.titleScreenReady));
	}
	,titleScreenReady: function() {
		this._gameLayer.addChild(this._screen);
		this._loadLayer.removeChild(this._loadingScreen);
		this._screen.start();
		this._screen.addEventListener("sceneRequest",$bind(this,this.sceneLoadRequest));
	}
	,screenReady: function() {
		this._gameLayer.addChild(this._screen);
		this._curtain.open($bind(this,this.onCurtainOpened));
		this._screen.addEventListener("sceneRequest",$bind(this,this.sceneLoadRequest));
	}
	,onCurtainOpened: function() {
		this._loadLayer.removeChild(this._curtain);
		this._screen.start();
	}
	,sceneLoadRequest: function(e) {
		if(e.get_data() != null) this._requestedCharacter = e.get_data(); else this._requestedCharacter = "Daniel";
		this._loadLayer.addChild(this._curtain);
		this._curtain.close($bind(this,this.loadScene));
	}
	,loadScene: function() {
		this._gameLayer.removeChild(this._screen);
		this._screen.destroy();
		this._screen = null;
		this._screen = new pbsdaniel_dressup_DressUpScene(pbsdaniel_dressup_DressUp.CharacterMap.get(this._requestedCharacter),pbsdaniel_dressup_DressUp.GameData,$bind(this,this.screenReady));
	}
	,__class__: pbsdaniel_dressup_DressUp
});
var sg_cjs_GameScreen = function() {
	this.sceneName = "unnamed";
	createjs.Container.call(this);
};
sg_cjs_GameScreen.__name__ = ["sg","cjs","GameScreen"];
sg_cjs_GameScreen.__super__ = createjs.Container;
sg_cjs_GameScreen.prototype = $extend(createjs.Container.prototype,{
	update: function(e) {
	}
	,destroy: function() {
	}
	,start: function() {
	}
	,getImageManifest: function() {
		var manifest = [];
		return manifest;
	}
	,getAudioManifest: function() {
		var manifest = [];
		return manifest;
	}
	,__class__: sg_cjs_GameScreen
});
var pbsdaniel_dressup_DressUpScene = function(character,sceneDef,readyCallback) {
	this._interactStartTime = 0;
	sg_cjs_GameScreen.call(this);
	this._readyCallback = readyCallback;
	this._data = sceneDef.data;
	this._assets = new sg_pbskids_AssetPackage(sceneDef.assetPackage.assetManifest,sceneDef.assetPackage.audioManifest,$bind(this,this.checkForSetup));
	this._character = new pbsdaniel_dressup_DressupCharacter(character,$bind(this,this.checkForSetup));
	this._anims = character.anims;
	this._assets.load();
};
pbsdaniel_dressup_DressUpScene.__name__ = ["pbsdaniel","dressup","DressUpScene"];
pbsdaniel_dressup_DressUpScene.__super__ = sg_cjs_GameScreen;
pbsdaniel_dressup_DressUpScene.prototype = $extend(sg_cjs_GameScreen.prototype,{
	destroy: function() {
		this._assets.dispose();
		this._assets = null;
		this._character.stopAnimation(true);
		this._character.dispose();
		this._character = null;
		sg_pbskids_audio_SRAudioManager.instance.killAll();
		this._readyCallback = null;
		this.removeAllChildren();
		this.removeAllEventListeners();
		if(this._currentIcon != null) this._currentIcon.destroy();
		if(this._currentHatIcon != null) this._currentHatIcon.destroy();
		if(this._currentTorsoIcon != null) this._currentTorsoIcon.destroy();
		if(this._currentShoeIcon != null) this._currentShoeIcon.destroy();
		if(this._currentFaceAccessoryIcon != null) this._currentFaceAccessoryIcon.destroy();
		if(this._currentChestAccessoryIcon != null) this._currentChestAccessoryIcon.destroy();
		if(this._currentBackAccessoryIcon != null) this._currentBackAccessoryIcon.destroy();
		var $it0 = this._categoryButtons.iterator();
		while( $it0.hasNext() ) {
			var btn = $it0.next();
			btn.destroy();
			btn = null;
		}
		window.removeEventListener("keydown",$bind(this,this.onKey));
		this._portraits.removeEventListener("mousedown",$bind(this,this.onPortraitsClicked),null);
	}
	,start: function() {
		if(this._character.get_characterId() == "Daniel" && !pbsdaniel_dressup_DressUp.IntroSeen) this._character.playIntro(); else this._character.gotoIdle();
		this._microphone.addEventListener("mousedown",$bind(this,this.onMicDown),null);
		this._portraits.addEventListener("mousedown",$bind(this,this.onPortraitsClicked),null);
		this._character.addEventListener("click",$bind(this,this.onCharacterClicked),null);
		var $it0 = this._categoryButtons.iterator();
		while( $it0.hasNext() ) {
			var button = $it0.next();
			button.addEventListener("mousedown",$bind(this,this.categoryButtonClicked),null);
		}
		var _g = 0;
		var _g1 = this._iconHolder._slots;
		while(_g < _g1.length) {
			var icon = _g1[_g];
			++_g;
			icon.addEventListener("mousedown",$bind(this,this.onIconDown),null);
		}
	}
	,killInput: function() {
		this._microphone.removeEventListener("mousedown",$bind(this,this.onMicDown),null);
		this._portraits.removeEventListener("mousedown",$bind(this,this.onPortraitsClicked),null);
		this._character.removeEventListener("click",$bind(this,this.onCharacterClicked),null);
		var $it0 = this._categoryButtons.iterator();
		while( $it0.hasNext() ) {
			var button = $it0.next();
			button.removeEventListener("mousedown",$bind(this,this.categoryButtonClicked),null);
		}
		var _g = 0;
		var _g1 = this._iconHolder._slots;
		while(_g < _g1.length) {
			var icon = _g1[_g];
			++_g;
			icon.removeEventListener("mousedown",$bind(this,this.onIconDown),null);
		}
	}
	,setupScene: function() {
		var bg = this._assets.getBitmap(this._data.background);
		this.addChild(bg);
		this._portraits = this._assets.getSpriteFromSheet(this._data.portraits);
		this._portraits.setTransform(15,15);
		this.addChild(this._portraits);
		this._microphone = this._assets.getSpriteFromSheet(this._data.spotlightButton);
		this._microphone.setTransform(232,0);
		this.addChild(this._microphone);
		this._spotlight = this._assets.getBitmap(this._data.spotlightCover);
		this._spotlight.alpha = 0;
		this.addChild(this._spotlight);
		this._character.setTransform(315,460);
		this._character.setRemovalCallback($bind(this,this.onItemDown));
		this._character.loopAnimation(this._anims.idle).tweenEnabled = true;
		this.addChild(this._character);
		this._iconHolder = new pbsdaniel_dressup_IconHolder();
		this._iconHolder.setCenterPoint(new createjs.Point(480,400));
		this._categoryButtons = new haxe_ds_StringMap();
		this._character.setupHitboxes(this.getHitboxesForCharacter(this._character.get_characterId()));
		var _g1 = 0;
		var _g = this._data.categories.length;
		while(_g1 < _g) {
			var i = _g1++;
			var button = new pbsdaniel_dressup_CategoryButton(this._data.categories[i]);
			button.setImage(this._assets.getSpriteFromSheet(this._data.categories[i].buttonImg));
			this.addChild(button);
			this._categoryButtons.set(this._data.categories[i].name,button);
		}
		this.populateIconHolder(this._categoryButtons.get(this._data.categories[0].name),false);
		this._readyCallback();
	}
	,onKey: function(e) {
		if(e.keyCode == 72) {
			if(this._debug_hitboxes == null) {
				var data = this.getHitboxesForCharacter(this._character.get_characterId());
				this._debug_hitboxes = new createjs.Shape();
				this._debug_hitboxes.graphics.beginFill("green").setStrokeStyle(4).beginStroke("black").drawRect(data.hat.x,data.hat.y,data.hat.width,data.hat.height).endStroke().endFill();
				this._debug_hitboxes.graphics.beginFill("green").setStrokeStyle(4).beginStroke("black").drawRect(data.accessory.x,data.accessory.y,data.accessory.width,data.accessory.height).endStroke().endFill();
				this._debug_hitboxes.graphics.beginFill("green").setStrokeStyle(4).beginStroke("black").drawRect(data.shoes.x,data.shoes.y,data.shoes.width,data.shoes.height).endStroke().endFill();
				this._debug_hitboxes.graphics.beginFill("green").setStrokeStyle(4).beginStroke("black").drawRect(data.torso.x,data.torso.y,data.torso.width,data.torso.height).endStroke().endFill();
				this.addChild(this._debug_hitboxes);
			} else {
				this.removeChild(this._debug_hitboxes);
				this._debug_hitboxes = null;
			}
		}
	}
	,onCharacterClicked: function(e) {
		this._character.playAdmire();
	}
	,onPortraitsClicked: function(e) {
		var _g = 0;
		var _g1 = this._data.hitAreas.pictures;
		while(_g < _g1.length) {
			var picture = _g1[_g];
			++_g;
			var rect = new createjs.Rectangle(picture.hitbox.x,picture.hitbox.y,picture.hitbox.width,picture.hitbox.height);
			rect.x += this._portraits.x;
			rect.y += this._portraits.y;
			if(rect.contains(e.stageX,e.stageY)) {
				this.killInput();
				this._portraits.removeEventListener("mousedown",$bind(this,this.onPortraitsClicked),null);
				this.dispatchEvent(new sg_cjs_SceneLoadEvent("sceneRequest","dressupScene",picture.id));
				break;
			}
		}
	}
	,getHitboxesForCharacter: function(characterId) {
		switch(characterId) {
		case "Chrissie":
			return this._data.hitAreas.chrissie;
		case "Daniel":
			return this._data.hitAreas.daniel;
		case "Elaina":
			return this._data.hitAreas.elaina;
		case "Katerina":
			return this._data.hitAreas.katerina;
		case "O":
			return this._data.hitAreas.o;
		case "Wednesday":
			return this._data.hitAreas.wednesday;
		}
		return null;
	}
	,categoryButtonClicked: function(e) {
		this.populateIconHolder(e.currentTarget);
	}
	,populateIconHolder: function(btn,autoListeners) {
		if(autoListeners == null) autoListeners = true;
		this._iconHolder.clear();
		var _g = 0;
		while(_g < 6) {
			var i = _g++;
			if(btn.config.items[i] != null) {
				var icon = new pbsdaniel_dressup_DressupIcon(btn.config.items[btn.atIndex]);
				icon.setImage(this._assets.getSpriteFromSheet(icon.config.icon));
				this._iconHolder.addIcon(icon);
				if(icon.inUse) icon.visible = false; else icon.visible = true;
				this.addChild(icon);
				btn.atIndex += 1;
				if(btn.atIndex >= btn.config.items.length) btn.atIndex = 0;
				if(autoListeners) icon.addEventListener("mousedown",$bind(this,this.onIconDown),null);
			}
		}
	}
	,onIconDown: function(e) {
		if(this._currentIcon == null) {
			sg_pbskids_audio_SRAudioManager.instance.playAudio(this._data.sfx.itempickups[Math.floor(Math.random() * this._data.sfx.itempickups.length)]);
			this._currentIcon = e.currentTarget;
			this._currentIcon.parent.addChild(this._currentIcon);
			this._currentIcon.NEOshadow.visible = false;
			this._interactStartTime = e.timeStamp;
			this.stage.addEventListener("stagemousemove",$bind(this,this.updateIconPoisition),null);
			this.stage.addEventListener("stagemouseup",$bind(this,this.releaseIcon),null);
		}
	}
	,releaseIcon: function(e) {
		this.stage.removeEventListener("stagemousemove",$bind(this,this.moveIcon),null);
		this.stage.removeEventListener("stagemousemove",$bind(this,this.updateIconPoisition),null);
		this.stage.removeEventListener("stagemouseup",$bind(this,this.releaseIcon),null);
		if(this.checkIconPlacement(e,this._currentIcon)) this._currentIcon = null; else if(e.timeStamp - this._interactStartTime < 400) {
			this.checkIconPlacement(e,this._currentIcon,true);
			this._currentIcon = null;
		} else if(this._currentIcon.doomed) {
			this._currentIcon.destroy();
			this.removeChild(this._currentIcon);
			this._currentIcon = null;
			sg_pbskids_audio_SRAudioManager.instance.playAudio(this._data.sfx.itemreturns[Math.floor(Math.random() * this._data.sfx.itemreturns.length)]);
		} else {
			this._currentIcon.allowDragAttach = true;
			this._currentIcon.reset();
			this._currentIcon.visible = true;
			this._currentIcon = null;
			sg_pbskids_audio_SRAudioManager.instance.playAudio(this._data.sfx.itemreturns[Math.floor(Math.random() * this._data.sfx.itemreturns.length)]);
		}
	}
	,updateIconPoisition: function(e) {
		if(this._currentIcon.draggable) {
			this._currentIcon.setTransform(e.stageX,e.stageY);
			if(this._currentIcon.allowDragAttach) {
				if(this.checkIconPlacement(e,this._currentIcon)) this._currentIcon = null;
			}
		}
	}
	,iconAdjustment: function(icon) {
		this.stage.removeEventListener("stagemousemove",$bind(this,this.updateIconPoisition),null);
		this.stage.removeEventListener("stagemouseup",$bind(this,this.releaseIcon),null);
		if(icon != null) {
			icon.inUse = false;
			if(icon.doomed) {
				icon.destroy();
				this.removeChild(icon);
				icon = null;
			} else icon.visible = true;
		}
	}
	,checkIconPlacement: function(e,icon,forcePlacement) {
		if(forcePlacement == null) forcePlacement = false;
		var _g = icon.config.type;
		switch(_g) {
		case "hat":
			if(this._character.hitboxes.hat.contains(e.stageX,e.stageY) || forcePlacement) {
				sg_pbskids_audio_SRAudioManager.instance.playAudio(this._data.sfx.wearhat);
				this.iconAdjustment(this._currentHatIcon);
				icon.inUse = true;
				this._currentHatIcon = icon;
				this._character.applyHat(icon);
				icon.reset();
				return true;
			}
			break;
		case "body":
			if(this._character.hitboxes.torso.contains(e.stageX,e.stageY) || forcePlacement) {
				sg_pbskids_audio_SRAudioManager.instance.playAudio(this._data.sfx.wearshirt);
				this.iconAdjustment(this._currentTorsoIcon);
				icon.inUse = true;
				this._currentTorsoIcon = icon;
				this._character.applyTorso(icon);
				icon.reset();
				return true;
			}
			break;
		case "feet":
			if(this._character.hitboxes.shoes.contains(e.stageX,e.stageY) || forcePlacement) {
				sg_pbskids_audio_SRAudioManager.instance.playAudio(this._data.sfx.wearshoes);
				this.iconAdjustment(this._currentShoeIcon);
				icon.inUse = true;
				this._currentShoeIcon = icon;
				this._character.applyShoes(icon);
				icon.reset();
				return true;
			}
			break;
		case "accessory":
			if(this._character.hitboxes.accessory.contains(e.stageX,e.stageY) || forcePlacement) {
				sg_pbskids_audio_SRAudioManager.instance.playAudio(this._data.sfx.wearaccessory);
				var _g1 = icon.config.slot;
				switch(_g1) {
				case "face":
					this.iconAdjustment(this._currentFaceAccessoryIcon);
					this._currentFaceAccessoryIcon = icon;
					break;
				case "chest":
					this.iconAdjustment(this._currentChestAccessoryIcon);
					this._currentChestAccessoryIcon = icon;
					break;
				case "back":
					this.iconAdjustment(this._currentBackAccessoryIcon);
					this._currentBackAccessoryIcon = icon;
					break;
				}
				icon.inUse = true;
				this._character.applyAccessory(icon,icon.config.slot);
				icon.reset();
				return true;
			}
			break;
		}
		return false;
	}
	,onItemDown: function(e,type) {
		if(this._currentIcon == null) {
			var storedIcon = null;
			switch(type) {
			case "hat":
				storedIcon = this._currentHatIcon;
				break;
			case "body":
				storedIcon = this._currentTorsoIcon;
				break;
			case "feet":
				storedIcon = this._currentShoeIcon;
				break;
			case "accessory_face":
				storedIcon = this._currentFaceAccessoryIcon;
				break;
			case "accessory_chest":
				storedIcon = this._currentChestAccessoryIcon;
				break;
			case "accessory_back":
				storedIcon = this._currentBackAccessoryIcon;
				break;
			}
			if(storedIcon.config.link != null) {
				this._currentIcon = storedIcon;
				this._currentIcon.allowDragAttach = false;
				this._currentIcon.visible = false;
				this._currentIcon.setTransform(e.stageX,e.stageY);
				this._currentIcon.NEOshadow.visible = false;
				this.addChild(this._currentIcon);
				this._interactStartTime = 0;
				this.stage.addEventListener("stagemouseup",$bind(this,this.falseStart),null);
				this.stage.addEventListener("stagemousemove",$bind(this,this.moveIcon),null);
			}
		}
	}
	,falseStart: function(e) {
		this.stage.removeEventListener("stagemouseup",$bind(this,this.falseStart),null);
		this.stage.removeEventListener("stagemousemove",$bind(this,this.moveIcon),null);
		this._currentIcon = null;
	}
	,moveIcon: function(e) {
		this._currentIcon.setTransform(e.stageX,e.stageY);
		if(!this._currentIcon.visible) {
			if(sg_cjs_utils_PointUtils.distance(new createjs.Point(e.stageX,e.stageY),this._currentIcon.originalPosition) > 45) {
				this._currentIcon.visible = true;
				this._currentIcon.inUse = false;
				this.stage.removeEventListener("stagemouseup",$bind(this,this.falseStart),null);
				this.stage.addEventListener("stagemouseup",$bind(this,this.releaseIcon),null);
				sg_pbskids_audio_SRAudioManager.instance.playAudio(this._data.sfx.itempickups[Math.floor(Math.random() * this._data.sfx.itempickups.length)]);
				this.removePiece();
			}
		}
	}
	,removePiece: function() {
		var _g = this._currentIcon.config.type;
		switch(_g) {
		case "hat":
			this._character.applyHat(null);
			break;
		case "body":
			this._character.applyTorso(null);
			break;
		case "feet":
			this._character.applyShoes(null);
			break;
		case "accessory":
			this._character.applyAccessory(null,this._currentIcon.config.slot);
			break;
		}
	}
	,checkForSetup: function() {
		if(this._assets.completed && this._character.completed) this.setupScene();
	}
	,onMicDown: function(e) {
		if(this._character.canSing()) {
			this._microphone.removeEventListener("mousedown",$bind(this,this.onMicDown),null);
			this._character.armature.addEventListener(dragonBones.events.AnimationEvent.COMPLETE,$bind(this,this.onPayoffComplete));
			createjs.Tween.get(this._spotlight).to({ alpha : 1},300).call(($_=this._character,$bind($_,$_.playPayoff)));
		}
	}
	,onPayoffComplete: function(e) {
		this._character.armature.removeEventListener(dragonBones.events.AnimationEvent.COMPLETE,$bind(this,this.onPayoffComplete));
		createjs.Tween.get(this._spotlight).to({ alpha : 0},300).call($bind(this,this.resetMic));
	}
	,resetMic: function() {
		this._microphone.addEventListener("mousedown",$bind(this,this.onMicDown),null);
	}
	,__class__: pbsdaniel_dressup_DressUpScene
});
var sg_cjs_dragonbones_DBCharacterCJS = function(data,readyCallback) {
	this.completed = false;
	createjs.Container.call(this);
	this._data = data;
	var characterManifest = [];
	characterManifest.push(data.skeleton);
	characterManifest.push(data.texture);
	characterManifest.push(data.textureJSON);
	this._assets = new sg_pbskids_AssetPackage(characterManifest,null,$bind(this,this.chracterDataLoaded));
	this._id = data.name;
	this._readyCallback = readyCallback;
	this._assets.load();
};
sg_cjs_dragonbones_DBCharacterCJS.__name__ = ["sg","cjs","dragonbones","DBCharacterCJS"];
sg_cjs_dragonbones_DBCharacterCJS.__super__ = createjs.Container;
sg_cjs_dragonbones_DBCharacterCJS.prototype = $extend(createjs.Container.prototype,{
	get_characterId: function() {
		return this._id;
	}
	,enableTweens: function(flag) {
		this.armature.animation.tweenEnabled = flag;
	}
	,playAnimation: function(label,completeCallback) {
		if(this.armature.animation.hasAnimation(label)) {
			if(completeCallback != null) {
				this._currentCompleteCallback = completeCallback;
				this.armature.addEventListener(dragonBones.events.AnimationEvent.COMPLETE,$bind(this,this.onAnimationComplete));
			}
			return this.armature.animation.gotoAndPlay(label);
		} else window.console.log("Animation does not contain label [" + label + "]");
		return null;
	}
	,loopAnimation: function(label,completeCallback) {
		if(this.armature.animation.hasAnimation(label)) return this.armature.animation.gotoAndPlay(label,-1,-1,1000); else window.console.log("Animation does not contain label [" + label + "]");
		return null;
	}
	,stopAnimation: function(killListeners) {
		if(killListeners == null) killListeners = false;
		if(killListeners) {
			this._currentCompleteCallback = null;
			this.armature.removeEventListener(dragonBones.events.AnimationEvent.COMPLETE,$bind(this,this.onAnimationComplete));
		}
		this.armature.animation.stop();
	}
	,onAnimationComplete: function(e) {
		this.armature.removeEventListener(dragonBones.events.AnimationEvent.COMPLETE,$bind(this,this.onAnimationComplete));
		this._currentCompleteCallback(e);
	}
	,chracterDataLoaded: function() {
		this._texture = this._assets.getImage(this._data.texture.id);
		this._textureData = this._assets.getResult(this._data.textureJSON.id);
		this._skeletonData = this._assets.getResult(this._data.skeleton.id);
		this._armatureName = this._data.armatureName;
		this.build();
	}
	,dispose: function() {
		this.removeAllEventListeners();
		this.removeAllChildren();
		this.removeChild(this.armature.getDisplay());
		this.armature.animation.stop();
		if(this.armature != null) {
			this.armature.removeAllEventListeners();
			this.armature = null;
		}
		this._readyCallback = null;
		this._texture = null;
		this._textureData = null;
		this._skeletonData = null;
		this._factory = null;
		this._id = null;
		this._assets.dispose();
		this._assets = null;
	}
	,onTextureLoaded: function(data) {
		this._filesToLoad--;
		this.charCreationCheck();
	}
	,charCreationCheck: function() {
		if(this._filesToLoad <= 0) this.build();
	}
	,onTextureDataLoaded: function(data) {
		this._textureData = data;
		this._filesToLoad--;
		this.charCreationCheck();
	}
	,onSkeletonDataLoaded: function(data) {
		this._skeletonData = data;
		this._filesToLoad--;
		this.charCreationCheck();
	}
	,build: function() {
		this._factory = new dragonBones.factorys.CreateJSFactory();
		this._factory.addSkeletonData(dragonBones.objects.DataParser.parseSkeletonData(this._skeletonData));
		var atlas = new dragonBones.textures.CreateJSTextureAtlas(this._texture,this._textureData);
		this._factory.addTextureAtlas(atlas);
		this.armature = this._factory.buildArmature(this._armatureName);
		this.addChild(this.armature.getDisplay());
		dragonBones.animation.WorldClock.clock.add(this.armature);
		this.armature.addEventListener(dragonBones.events.FrameEvent.BONE_FRAME_EVENT,$bind(this,this.omBoneFrameEvent));
		this.completed = true;
		if(this._readyCallback != null) this._readyCallback();
	}
	,omBoneFrameEvent: function(e) {
		if(e.frameLabel.indexOf("vo_") != -1) sg_pbskids_audio_SRAudioManager.instance.playVO(e.frameLabel.split("vo_")[1]); else if(e.frameLabel.indexOf("sfx_") != -1) sg_pbskids_audio_SRAudioManager.instance.playAudio(e.frameLabel.split("sfx_")[1]); else sg_pbskids_audio_SRAudioManager.instance.playAudio(e.frameLabel);
	}
	,__class__: sg_cjs_dragonbones_DBCharacterCJS
});
var sg_springroll_dragonbones_SRDBCharacter = function(data,readyCallback) {
	sg_cjs_dragonbones_DBCharacterCJS.call(this,data,readyCallback);
};
sg_springroll_dragonbones_SRDBCharacter.__name__ = ["sg","springroll","dragonbones","SRDBCharacter"];
sg_springroll_dragonbones_SRDBCharacter.__super__ = sg_cjs_dragonbones_DBCharacterCJS;
sg_springroll_dragonbones_SRDBCharacter.prototype = $extend(sg_cjs_dragonbones_DBCharacterCJS.prototype,{
	chracterDataLoaded: function() {
		this._texture = this._assets.getImage(this._data.texture.id);
		this._textureData = this._assets.getResult(this._data.textureJSON.id);
		this._skeletonData = this._assets.getResult(this._data.skeleton.id);
		this._armatureName = this._data.armatureName;
		this.preloadAudio(this._skeletonData);
		this.build();
	}
	,preloadAudio: function(skeleton) {
		var audioMani = [];
		this._audioLoaded = false;
		var _g = 0;
		var _g1 = skeleton.armature;
		while(_g < _g1.length) {
			var armature = _g1[_g];
			++_g;
			var _g2 = 0;
			var _g3 = armature.animation;
			while(_g2 < _g3.length) {
				var animation = _g3[_g2];
				++_g2;
				if(animation.timeline != null) {
					var _g4 = 0;
					var _g5 = animation.timeline;
					while(_g4 < _g5.length) {
						var timeline = _g5[_g4];
						++_g4;
						var _g6 = 0;
						var _g7 = timeline.frame;
						while(_g6 < _g7.length) {
							var frame = _g7[_g6];
							++_g6;
							if(frame.event != null) {
								var audioID = "";
								if(frame.event.indexOf("vo_") > -1) audioID = HxOverrides.substr(frame.event,3,null); else if(frame.event.indexOf("sfx_") > -1) audioID = HxOverrides.substr(frame.event,4,null);
								audioMani.push(sg_pbskids_AssetPackage.makeAudioManifestItem(audioID));
							}
						}
					}
				}
			}
		}
		if(audioMani.length > 0) sg_pbskids_audio_SRAudioManager.instance.loadAudio(audioMani,$bind(this,this.characterAudioLoaded)); else {
			this._audioLoaded = true;
			this.characterAudioLoaded();
		}
	}
	,characterAudioLoaded: function() {
		this._audioLoaded = true;
		if(this._readyCallback != null && this.completed) this._readyCallback();
	}
	,build: function() {
		this._factory = new dragonBones.factorys.CreateJSFactory();
		this._factory.addSkeletonData(dragonBones.objects.DataParser.parseSkeletonData(this._skeletonData));
		var atlas = new dragonBones.textures.CreateJSTextureAtlas(this._texture,this._textureData);
		this._factory.addTextureAtlas(atlas);
		this.armature = this._factory.buildArmature(this._armatureName);
		this.addChild(this.armature.getDisplay());
		dragonBones.animation.WorldClock.clock.add(this.armature);
		this.armature.addEventListener(dragonBones.events.FrameEvent.BONE_FRAME_EVENT,$bind(this,this.omBoneFrameEvent));
		this.completed = true;
		if(this._readyCallback != null && this._audioLoaded) this._readyCallback();
	}
	,__class__: sg_springroll_dragonbones_SRDBCharacter
});
var pbsdaniel_dressup_DressupCharacter = function(data,readyCallback) {
	this.swapArmatureNames = ["hat_swap","torso_swap","left_arm_swap","right_arm_swap","left_leg_swap","right_leg_swap","cape_swap","left_shoe_swap","right_shoe_swap","left_boot_swap","right_boot_swap","head_accessory_swap","back_accessory_swap","accessory_swap"];
	this._offering = false;
	this._piecesPlaced = 0;
	sg_springroll_dragonbones_SRDBCharacter.call(this,data.dragonBonesData,readyCallback);
	this._charaterData = data;
	this._anims = this._charaterData.anims;
	this._currentState = pbsdaniel_dressup_DressupCharacter.IDLE;
	this._reactions = this._anims.positive.slice().concat(this._anims.negative.slice());
	var outArr = [];
	while(this._reactions.length > 0) outArr.push(this._reactions.splice(Math.floor(Math.random() * this._reactions.length),1)[0]);
	this._reactions = outArr;
};
pbsdaniel_dressup_DressupCharacter.__name__ = ["pbsdaniel","dressup","DressupCharacter"];
pbsdaniel_dressup_DressupCharacter.__super__ = sg_springroll_dragonbones_SRDBCharacter;
pbsdaniel_dressup_DressupCharacter.prototype = $extend(sg_springroll_dragonbones_SRDBCharacter.prototype,{
	build: function() {
		this._factory = new dragonBones.factorys.CreateJSFactory();
		this._factory.addSkeletonData(dragonBones.objects.DataParser.parseSkeletonData(this._skeletonData));
		var atlas = new dragonBones.textures.CreateJSTextureAtlas(this._texture,this._textureData);
		this._factory.addTextureAtlas(atlas);
		this.armature = this._factory.buildArmature(this._armatureName);
		this.addChild(this.armature.getDisplay());
		dragonBones.animation.WorldClock.clock.add(this.armature);
		this.armature.addEventListener(dragonBones.events.FrameEvent.BONE_FRAME_EVENT,$bind(this,this.omBoneFrameEvent));
		this._swapArmatures = new haxe_ds_StringMap();
		this.buildNextSwapArmature();
	}
	,buildNextSwapArmature: function() {
		var armatureID = this.swapArmatureNames.shift();
		var swapArmature = this._factory.buildArmature(armatureID);
		this._swapArmatures.set(armatureID,swapArmature);
		if(this.swapArmatureNames.length > 0) createjs.Tween.get(this).wait(100,false).call($bind(this,this.buildNextSwapArmature)); else createjs.Tween.get(this).wait(100,false).call($bind(this,this.callCompletion));
	}
	,callCompletion: function() {
		this.completed = true;
		if(this._readyCallback != null && this._audioLoaded) this._readyCallback();
	}
	,setRemovalCallback: function(callback) {
		this._removalCallback = callback;
	}
	,applyHat: function(icon) {
		var hat_slot;
		if(icon != null) hat_slot = this._swapArmatures.get("hat_swap").getSlot(icon.config.link); else hat_slot = this._swapArmatures.get("hat_swap").getSlots()[0];
		this.armature.getSlot("head").getChildArmature().getSlot("hat").setDisplayList(hat_slot.getDisplayList());
		if(!this.singing && icon != null) this.playReaction(this._anims.reactHat);
		if(icon != null) this.armature.getSlot("head").getChildArmature().getSlot("hat").getDisplay().on("mousedown",$bind(this,this.initiateHatRemoval));
	}
	,initiateHatRemoval: function(e) {
		if(this._removalCallback != null) this._removalCallback(e,"hat");
	}
	,applyTorso: function(icon) {
		var body_slot;
		var l_arm_slot;
		var r_arm_slot;
		var l_leg_slot;
		var r_leg_slot;
		var cape_slot;
		if(icon != null) {
			body_slot = this._swapArmatures.get("torso_swap").getSlot(icon.config.link);
			l_arm_slot = this._swapArmatures.get("left_arm_swap").getSlot(icon.config.link);
			r_arm_slot = this._swapArmatures.get("right_arm_swap").getSlot(icon.config.link);
			l_leg_slot = this._swapArmatures.get("left_leg_swap").getSlot(icon.config.link);
			r_leg_slot = this._swapArmatures.get("right_leg_swap").getSlot(icon.config.link);
			cape_slot = this._swapArmatures.get("cape_swap").getSlot(icon.config.link);
		} else {
			body_slot = this._swapArmatures.get("torso_swap").getSlots()[0];
			l_arm_slot = this._swapArmatures.get("left_arm_swap").getSlots()[0];
			r_arm_slot = this._swapArmatures.get("right_arm_swap").getSlots()[0];
			l_leg_slot = this._swapArmatures.get("left_leg_swap").getSlots()[0];
			r_leg_slot = this._swapArmatures.get("right_leg_swap").getSlots()[0];
			cape_slot = this._swapArmatures.get("cape_swap").getSlots()[0];
		}
		if(cape_slot != null) this.armature.getSlot("cape").setDisplayList(cape_slot.getDisplayList()); else this.armature.getSlot("cape").setDisplayList([]);
		this.armature.getSlot("torso").setDisplayList(body_slot.getDisplayList());
		this.armature.getSlot("left_arm").setDisplayList(l_arm_slot.getDisplayList());
		this.armature.getSlot("right_arm").setDisplayList(r_arm_slot.getDisplayList());
		if(l_leg_slot != null) this.armature.getSlot("left_leg").setDisplayList(l_leg_slot.getDisplayList()); else this.armature.getSlot("left_leg").setDisplayList([]);
		if(r_leg_slot != null) this.armature.getSlot("right_leg").setDisplayList(r_leg_slot.getDisplayList()); else this.armature.getSlot("right_leg").setDisplayList([]);
		if(!this.singing && icon != null) this.playReaction(this._anims.reactCostume);
		if(icon != null) {
			this.armature.getSlot("torso").getDisplay().on("mousedown",$bind(this,this.initiateTorsoRemoval));
			this.armature.getSlot("left_arm").getDisplay().on("mousedown",$bind(this,this.initiateTorsoRemoval));
			this.armature.getSlot("right_arm").getDisplay().on("mousedown",$bind(this,this.initiateTorsoRemoval));
			if(this.armature.getSlot("left_leg").getDisplay() != null) {
				this.armature.getSlot("left_leg").getDisplay().on("mousedown",$bind(this,this.initiateTorsoRemoval));
				this.armature.getSlot("right_leg").getDisplay().on("mousedown",$bind(this,this.initiateTorsoRemoval));
			}
		}
	}
	,initiateTorsoRemoval: function(e) {
		if(this._removalCallback != null) this._removalCallback(e,"body");
	}
	,applyShoes: function(icon) {
		var left_shoe_slot;
		var right_shoe_slot;
		var left_boot_slot;
		var right_boot_slot;
		if(icon != null) {
			left_shoe_slot = this._swapArmatures.get("left_shoe_swap").getSlot(icon.config.link);
			right_shoe_slot = this._swapArmatures.get("right_shoe_swap").getSlot(icon.config.link);
			left_boot_slot = this._swapArmatures.get("left_boot_swap").getSlot(icon.config.link);
			right_boot_slot = this._swapArmatures.get("right_boot_swap").getSlot(icon.config.link);
		} else {
			left_shoe_slot = this._swapArmatures.get("left_shoe_swap").getSlots()[0];
			right_shoe_slot = this._swapArmatures.get("right_shoe_swap").getSlots()[0];
			left_boot_slot = this._swapArmatures.get("left_boot_swap").getSlots()[0];
			right_boot_slot = this._swapArmatures.get("right_boot_swap").getSlots()[0];
		}
		this.armature.getSlot("left_foot").setDisplayList(left_shoe_slot.getDisplayList());
		this.armature.getSlot("right_foot").setDisplayList(right_shoe_slot.getDisplayList());
		if(left_boot_slot != null) this.armature.getSlot("left_boot").setDisplayList(left_boot_slot.getDisplayList()); else this.armature.getSlot("left_boot").setDisplayList([]);
		if(right_boot_slot != null) this.armature.getSlot("right_boot").setDisplayList(right_boot_slot.getDisplayList()); else this.armature.getSlot("right_boot").setDisplayList([]);
		if(!this.singing && icon != null) this.playReaction(this._anims.reactFeet);
		if(icon != null) {
			this.armature.getSlot("left_foot").getDisplay().on("mousedown",$bind(this,this.initiateShoeRemoval));
			this.armature.getSlot("right_foot").getDisplay().on("mousedown",$bind(this,this.initiateShoeRemoval));
			if(this.armature.getSlot("left_boot").getDisplay() != null) {
				this.armature.getSlot("left_boot").getDisplay().on("mousedown",$bind(this,this.initiateShoeRemoval));
				this.armature.getSlot("right_boot").getDisplay().on("mousedown",$bind(this,this.initiateShoeRemoval));
			}
		}
	}
	,initiateShoeRemoval: function(e) {
		if(this._removalCallback != null) this._removalCallback(e,"feet");
	}
	,applyAccessory: function(icon,slot) {
		if(slot != null) switch(slot) {
		case "face":
			var face_slot;
			if(icon != null) face_slot = this._swapArmatures.get("head_accessory_swap").getSlot(icon.config.link); else face_slot = this._swapArmatures.get("head_accessory_swap").getSlots()[0];
			this.armature.getSlot("head").getChildArmature().getSlot("head_accessory").setDisplayList(face_slot.getDisplayList());
			if(icon != null) this.armature.getSlot("head").getChildArmature().getSlot("head_accessory").getDisplay().on("mousedown",$bind(this,this.initiateFaceRemoval));
			break;
		case "back":
			var back_slot;
			if(icon != null) back_slot = this._swapArmatures.get("back_accessory_swap").getSlot(icon.config.link); else back_slot = this._swapArmatures.get("back_accessory_swap").getSlots()[0];
			this.armature.getSlot("back_accessory").setDisplayList(back_slot.getDisplayList());
			if(icon != null) this.armature.getSlot("back_accessory").getDisplay().on("mousedown",$bind(this,this.initiateBackRemoval));
			break;
		case "chest":
			var chest_slot;
			if(icon != null) chest_slot = this._swapArmatures.get("accessory_swap").getSlot(icon.config.link); else chest_slot = this._swapArmatures.get("accessory_swap").getSlots()[0];
			this.armature.getSlot("accessory").setDisplayList(chest_slot.getDisplayList());
			if(icon != null) this.armature.getSlot("accessory").getDisplay().on("mousedown",$bind(this,this.initiateChestRemoval));
			break;
		}
		if(!this.singing && icon != null) this.playReaction(this._anims.reactFace);
	}
	,initiateFaceRemoval: function(e) {
		if(this._removalCallback != null) this._removalCallback(e,"accessory_face");
	}
	,initiateBackRemoval: function(e) {
		if(this._removalCallback != null) this._removalCallback(e,"accessory_back");
	}
	,initiateChestRemoval: function(e) {
		if(this._removalCallback != null) this._removalCallback(e,"accessory_chest");
	}
	,setupHitboxes: function(hitboxDef) {
		this.hitboxes = new pbsdaniel_dressup_CharacterHitboxes(hitboxDef);
	}
	,playIntro: function() {
		if(this._currentState == pbsdaniel_dressup_DressupCharacter.IDLE && this.armature.animation.hasAnimation(this._anims.welcome)) {
			this._currentState = pbsdaniel_dressup_DressupCharacter.INTRO;
			pbsdaniel_dressup_DressUp.IntroSeen = true;
			this.playAnimation(this._anims.welcome,$bind(this,this.gotoIdle)).tweenEnabled = true;
		}
	}
	,suggestFriend: function() {
		if(this._currentState == pbsdaniel_dressup_DressupCharacter.IDLE && this.armature.animation.hasAnimation(this._anims.offer)) {
			this._currentState = pbsdaniel_dressup_DressupCharacter.FRIEND;
			this.playAnimation(this._anims.offer,$bind(this,this.gotoIdle)).tweenEnabled = true;
		}
	}
	,playPayoff: function() {
		if(this._currentState != "payoff" && this.armature.animation.hasAnimation(this._anims.payoff)) {
			this._currentState = "payoff";
			this.playAnimation(this._anims.payoff,$bind(this,this.gotoIdle)).tweenEnabled = true;
		}
	}
	,playAdmire: function() {
		if(this._currentState == pbsdaniel_dressup_DressupCharacter.IDLE) {
			this.playAnimation(this._anims.admire,$bind(this,this.gotoIdle)).tweenEnabled = true;
			this._currentState = pbsdaniel_dressup_DressupCharacter.REACTING;
		}
	}
	,playReaction: function(fallback) {
		if(this._currentState == pbsdaniel_dressup_DressupCharacter.IDLE) {
			if(this._piecesPlaced % 7 == 0) {
				var reaction = this._reactions.shift();
				this.playAnimation(reaction,$bind(this,this.gotoIdle)).tweenEnabled = true;
				this._reactions.push(reaction);
			} else this.playAnimation(fallback,$bind(this,this.gotoIdle)).tweenEnabled = true;
			this._currentState = pbsdaniel_dressup_DressupCharacter.REACTING;
		}
		this._piecesPlaced += 1;
	}
	,gotoIdle: function(e) {
		this._currentState = pbsdaniel_dressup_DressupCharacter.IDLE;
		this.loopAnimation(this._anims.idle).tweenEnabled = true;
		if(this.get_characterId() == "Daniel") {
			createjs.Tween.removeTweens(this);
			createjs.Tween.get(this).wait(120000,false).call($bind(this,this.suggestFriend));
		}
	}
	,canSing: function() {
		return this._currentState != "payoff" && this._currentState != pbsdaniel_dressup_DressupCharacter.INTRO;
	}
	,__class__: pbsdaniel_dressup_DressupCharacter
});
var pbsdaniel_dressup_CharacterHitboxes = function(def) {
	this.hat = new createjs.Rectangle(def.hat.x,def.hat.y,def.hat.width,def.hat.height);
	this.torso = new createjs.Rectangle(def.torso.x,def.torso.y,def.torso.width,def.torso.height);
	this.shoes = new createjs.Rectangle(def.shoes.x,def.shoes.y,def.shoes.width,def.shoes.height);
	this.accessory = new createjs.Rectangle(def.accessory.x,def.accessory.y,def.accessory.width,def.accessory.height);
};
pbsdaniel_dressup_CharacterHitboxes.__name__ = ["pbsdaniel","dressup","CharacterHitboxes"];
pbsdaniel_dressup_CharacterHitboxes.prototype = {
	__class__: pbsdaniel_dressup_CharacterHitboxes
};
var pbsdaniel_dressup_DressupIcon = function(cfg) {
	this.allowDragAttach = true;
	this.doomed = false;
	createjs.Container.call(this);
	this.config = cfg;
	var bmp;
	this.draggable = true;
	this.inUse = false;
};
pbsdaniel_dressup_DressupIcon.__name__ = ["pbsdaniel","dressup","DressupIcon"];
pbsdaniel_dressup_DressupIcon.__super__ = createjs.Container;
pbsdaniel_dressup_DressupIcon.prototype = $extend(createjs.Container.prototype,{
	destroy: function() {
		this.removeAllChildren();
		this.removeAllEventListeners();
	}
	,setImage: function(sprite) {
		this.image = sprite;
		this.image.regX = this.image.getBounds().width * .5;
		this.image.regY = this.image.getBounds().height * .5;
		this._hitbox = new createjs.Shape();
		this._hitbox.graphics.beginFill("white").rect(0,0,this.image.getBounds().width,this.image.getBounds().height).endFill();
		this._hitbox.alpha = 0.01;
		this._hitbox.setTransform(this.image.x - this.image.regX,this.image.y - this.image.regY);
		this.NEOshadow = new createjs.Shape();
		this.NEOshadow.graphics.beginFill("black").drawEllipse(0,0,this.image.getBounds().width,15);
		this.NEOshadow.alpha = 0.2;
		this.NEOshadow.setTransform(this.image.x - this.image.regX,this.image.y + this.image.getBounds().height * .35);
		this.addChild(this.NEOshadow);
		this.addChild(this._hitbox);
		this.addChild(this.image);
	}
	,reset: function() {
		this.draggable = true;
		this.NEOshadow.visible = true;
		this.visible = false;
		this.setTransform(this.originalPosition.x,this.originalPosition.y);
	}
	,__class__: pbsdaniel_dressup_DressupIcon
});
var pbsdaniel_dressup_IconHolder = function() {
	createjs.Container.call(this);
	this._slots = [];
};
pbsdaniel_dressup_IconHolder.__name__ = ["pbsdaniel","dressup","IconHolder"];
pbsdaniel_dressup_IconHolder.__super__ = createjs.Container;
pbsdaniel_dressup_IconHolder.prototype = $extend(createjs.Container.prototype,{
	setCenterPoint: function(point) {
		this._centerPoint = point;
	}
	,addIcon: function(icon) {
		this._slots.push(icon);
		if(this._slots.length < 4) icon.originalPosition = new createjs.Point(550,110 + (this._slots.length - 1) * 140); else icon.originalPosition = new createjs.Point(675,110 + (this._slots.length - 4) * 140);
		icon.setTransform(icon.originalPosition.x,icon.originalPosition.y);
		icon.addEventListener("mouseover",$bind(this,this.onIconOver),null);
		icon.addEventListener("mouseout",$bind(this,this.onIconOut),null);
	}
	,onIconOut: function(e) {
		var icon = e.currentTarget;
		icon.image.scaleX = icon.image.scaleY = 1;
	}
	,onIconOver: function(e) {
		var icon = e.currentTarget;
		icon.image.scaleX = icon.image.scaleY = 1.1;
	}
	,clear: function() {
		var _g = 0;
		var _g1 = this._slots;
		while(_g < _g1.length) {
			var slot = _g1[_g];
			++_g;
			if(!slot.inUse) {
				slot.removeAllChildren();
				this.removeChild(slot);
				slot.removeEventListener("mouseover",$bind(this,this.onIconOver),null);
				slot.removeEventListener("mouseout",$bind(this,this.onIconOut),null);
				slot = null;
			} else slot.doomed = true;
		}
		this._slots = [];
	}
	,__class__: pbsdaniel_dressup_IconHolder
});
var pbsdaniel_dressup_Main = function() { };
pbsdaniel_dressup_Main.__name__ = ["pbsdaniel","dressup","Main"];
pbsdaniel_dressup_Main.main = function() {
	window.SGGameButler = new sg_kit_PBSGameButler("DressUp",pbsdaniel_dressup_Main.start);
	pbsdaniel_dressup_Main._isSpringroll = typeof springroll != "undefined";
};
pbsdaniel_dressup_Main.start = function(springrollApp,bellhop) {
	pbsdaniel_dressup_Main.SpringrollApp = springrollApp;
	pbsdaniel_dressup_Main._bellhop = bellhop;
	sg_pbskids_audio_SRAudioManager.init(pbsdaniel_dressup_Main.SpringrollApp);
	window.focus();
	pbsdaniel_dressup_Main._game = new pbsdaniel_dressup_DressUp(pbsdaniel_dressup_Main.SpringrollApp);
	pbsdaniel_dressup_Main._game.begin();
};
pbsdaniel_dressup_Main.ga_call = function(payload) {
	try {
		pbsdaniel_dressup_Main._bellhop.send("gacall",payload);
	} catch( e ) {
		if( js_Boot.__instanceof(e,Error) ) {
			window.console.warn("Warning: " + Std.string(e));
		} else throw(e);
	}
};
var sg_cjs_AssetLoader = function(manifest,spriteSheetId,spriteSheetDataId) {
	this._manifest = manifest;
	this._spriteSheetId = spriteSheetId;
	this._spriteSheetDataId = spriteSheetDataId;
};
sg_cjs_AssetLoader.__name__ = ["sg","cjs","AssetLoader"];
sg_cjs_AssetLoader.prototype = {
	loadSpriteSheet: function(callback) {
		if(this._queue != null) callback(); else {
			this._callback = callback;
			this._queue = new createjs.LoadQueue(true);
			this._queue.on("complete",$bind(this,this.createSpriteSheet));
			this._queue.loadManifest(this._manifest);
		}
	}
	,createSpriteSheet: function() {
		var itemData = this._queue.getResult(this._spriteSheetDataId);
		itemData.images = [this._queue.getResult(this._spriteSheetId)];
		this._spriteSheet = new createjs.SpriteSheet(itemData);
		this._callback();
	}
	,image: function(id) {
		var sprite = new createjs.Sprite(this._spriteSheet);
		sprite.gotoAndStop(id);
		return sprite;
	}
	,__class__: sg_cjs_AssetLoader
};
var sg_cjs_SceneLoadEvent = function(type,id,payload,bubbles,cancelable) {
	if(cancelable == null) cancelable = false;
	if(bubbles == null) bubbles = false;
	createjs.Event.call(this,type,bubbles,cancelable);
	this.sceneId = id;
	this.data = payload;
};
sg_cjs_SceneLoadEvent.__name__ = ["sg","cjs","SceneLoadEvent"];
sg_cjs_SceneLoadEvent.__super__ = createjs.Event;
sg_cjs_SceneLoadEvent.prototype = $extend(createjs.Event.prototype,{
	get_sceneId: function() {
		return this.sceneId;
	}
	,get_data: function() {
		return this.data;
	}
	,__class__: sg_cjs_SceneLoadEvent
});
var sg_cjs_ui_HoverButton = function(off,over,down,altHitbox) {
	createjs.Container.call(this);
	if(altHitbox == null) altHitbox = off.getBounds();
	this._hitbox = new createjs.Shape();
	this._hitbox.graphics.beginFill("#00ff00");
	this._hitbox.graphics.drawRect(altHitbox.x,altHitbox.y,altHitbox.width,altHitbox.height);
	this._hitbox.graphics.endFill();
	this._hitbox.alpha = .01;
	this._off = off;
	this.addChildAt(this._off,0);
	if(over != null) this.addOver(over);
	if(down == null && this._over != null) this._down = this._over;
	this.addChild(this._hitbox);
};
sg_cjs_ui_HoverButton.__name__ = ["sg","cjs","ui","HoverButton"];
sg_cjs_ui_HoverButton.__super__ = createjs.Container;
sg_cjs_ui_HoverButton.prototype = $extend(createjs.Container.prototype,{
	forceOver: function() {
		this._over.visible = true;
		this._off.visible = false;
	}
	,forceOut: function() {
		this._over.visible = false;
		this._off.visible = true;
	}
	,turnOn: function() {
		this._hitbox.addEventListener("mousedown",$bind(this,this.onDown));
		if(this._over != null) {
			this._hitbox.addEventListener("mouseover",$bind(this,this.onOver));
			this._hitbox.addEventListener("mouseout",$bind(this,this.onOut));
		}
	}
	,turnOff: function() {
		this._hitbox.removeEventListener("mousedown",$bind(this,this.onDown));
		if(this._over != null) {
			this._hitbox.removeEventListener("mouseover",$bind(this,this.onOver));
			this._hitbox.removeEventListener("mouseout",$bind(this,this.onOut));
		}
	}
	,onOut: function(e) {
		this._over.visible = false;
		this._off.visible = true;
	}
	,onOver: function(e) {
		this._over.visible = true;
		this._off.visible = false;
		this.dispatchEvent(new createjs.Event("over",false,false));
	}
	,onDown: function(e) {
		if(this._down != null) {
			this._over.visible = false;
			this._off.visible = false;
			this._down.visible = true;
		}
		this.dispatchEvent(new createjs.Event("down",false,false));
	}
	,addOver: function(img,offset,clearOff) {
		if(clearOff == null) clearOff = false;
		this._over = img;
		if(offset != null) {
			this._over.x = offset.x;
			this._over.y = offset.y;
		}
		this.addChildAt(this._over,0);
		this._over.visible = false;
		this._clearOnOver = clearOff;
	}
	,destroy: function() {
		this.removeAllChildren();
		this.turnOff();
	}
	,__class__: sg_cjs_ui_HoverButton
});
var sg_cjs_utils_PointUtils = function() { };
sg_cjs_utils_PointUtils.__name__ = ["sg","cjs","utils","PointUtils"];
sg_cjs_utils_PointUtils.findAngle = function(p0,p1,p2) {
	var b = Math.pow(p1.x - p0.x,2) + Math.pow(p1.y - p0.y,2);
	var a = Math.pow(p1.x - p2.x,2) + Math.pow(p1.y - p2.y,2);
	var c = Math.pow(p2.x - p0.x,2) + Math.pow(p2.y - p0.y,2);
	return Math.acos((a + b - c) / Math.sqrt(4 * a * b));
};
sg_cjs_utils_PointUtils.distance = function(p1,p2) {
	return Math.sqrt((p2.x - p1.x) * (p2.x - p1.x) + (p2.y - p1.y) * (p2.y - p1.y));
};
var sg_cjs_views_LoadingAnimation = function() {
	sg_cjs_AssetLoader.call(this,sg_cjs_views_LoadingAnimation.manifest(),"loadingSpriteSheet","loadingData");
};
sg_cjs_views_LoadingAnimation.__name__ = ["sg","cjs","views","LoadingAnimation"];
sg_cjs_views_LoadingAnimation.get_instance = function() {
	if(sg_cjs_views_LoadingAnimation.instance == null) sg_cjs_views_LoadingAnimation.instance = new sg_cjs_views_LoadingAnimation();
	return sg_cjs_views_LoadingAnimation.instance;
};
sg_cjs_views_LoadingAnimation.manifest = function() {
	return [{ src : "assets/sheets/loading.png", id : "loadingSpriteSheet"},{ src : "assets/sheets/loading.json", id : "loadingData"}];
};
sg_cjs_views_LoadingAnimation.load = function(callback) {
	sg_cjs_views_LoadingAnimation.get_instance().loadSpriteSheet(callback);
};
sg_cjs_views_LoadingAnimation.loadingAnimation = function() {
	return new createjs.Sprite(sg_cjs_views_LoadingAnimation.get_instance()._spriteSheet,"Loading");
};
sg_cjs_views_LoadingAnimation.__super__ = sg_cjs_AssetLoader;
sg_cjs_views_LoadingAnimation.prototype = $extend(sg_cjs_AssetLoader.prototype,{
	__class__: sg_cjs_views_LoadingAnimation
});
var sg_cjs_views_LoadingScreen = function() {
	sg_cjs_GameScreen.call(this);
};
sg_cjs_views_LoadingScreen.__name__ = ["sg","cjs","views","LoadingScreen"];
sg_cjs_views_LoadingScreen.__super__ = sg_cjs_GameScreen;
sg_cjs_views_LoadingScreen.prototype = $extend(sg_cjs_GameScreen.prototype,{
	init: function() {
		this._assets = new sg_pbskids_AssetPackage(this.getImageManifest(),this.getAudioManifest(),$bind(this,this.onPackageReady));
		this._assets.load();
	}
	,onPackageReady: function() {
	}
	,start: function() {
	}
	,freeze: function() {
	}
	,getImageManifest: function() {
		return [];
	}
	,getAudioManifest: function() {
		return [];
	}
	,__class__: sg_cjs_views_LoadingScreen
});
var sg_kit_PBSGameButler = function(id,startCall) {
	this._started = false;
	this.name = id;
	this._startCall = startCall;
};
sg_kit_PBSGameButler.__name__ = ["sg","kit","PBSGameButler"];
sg_kit_PBSGameButler.prototype = {
	startGame: function(app,bellhop) {
		if(!this._started) this._startCall(app,bellhop);
	}
	,get_name: function() {
		return this.name;
	}
	,__class__: sg_kit_PBSGameButler
};
var sg_pbskids_AssetPackage = function(imgManifest,audioManifest,completeCallback,basePath) {
	if(basePath == null) basePath = "";
	this.completed = false;
	this._sheetCount = 0;
	this._imagesLoaded = false;
	this._audioLoaded = false;
	this._imgManifest = imgManifest;
	this._audioManifest = audioManifest;
	this._completeCallback = completeCallback;
	this._loadQueue = new createjs.LoadQueue(true,basePath);
	createjs.Sound.alternateExtensions = ["mp3","wav"];
	this._loadQueue.installPlugin(createjs.Sound);
	this._audioManager = sg_pbskids_audio_SRAudioManager.instance;
};
sg_pbskids_AssetPackage.__name__ = ["sg","pbskids","AssetPackage"];
sg_pbskids_AssetPackage.makeManifestItem = function(id,src,type) {
	return { id : id, src : src, type : type};
};
sg_pbskids_AssetPackage.makeAudioManifestItem = function(id) {
	return { id : id};
};
sg_pbskids_AssetPackage.prototype = {
	load: function() {
		if(this._audioManifest != null) {
			if(this._audioManifest.length > 0) sg_pbskids_audio_SRAudioManager.instance.loadAudio(this._audioManifest,$bind(this,this.onAudioLoaded)); else this._audioLoaded = true;
		} else this._audioLoaded = true;
		this.loadManifest(this._imgManifest);
	}
	,dispose: function() {
		this._loadQueue.removeAll();
		this._loadQueue.close();
		this._loadQueue = null;
		this._imgManifest = null;
		this._audioManifest = null;
		this._sheets = null;
		this._completeCallback = null;
	}
	,getSpriteFromSheet: function(spriteName,sheetName) {
		if(sheetName == null || sheetName == "") {
			var items = this._loadQueue.getItems(true);
			var _g1 = 0;
			var _g = items.length;
			while(_g1 < _g) {
				var i = _g1++;
				if(items[i].item.type == "spritesheet") {
					if(this._loadQueue.getResult(items[i].item.id).animations.indexOf(spriteName) != -1) {
						var sprite = new createjs.Sprite(this._loadQueue.getResult(items[i].item.id),spriteName);
						return sprite;
					}
				}
			}
		} else {
			var sprite1 = new createjs.Sprite(this._loadQueue.getResult(sheetName),spriteName);
			return sprite1;
		}
		return null;
	}
	,getBitmap: function(id) {
		var item = this._loadQueue.getResult(id);
		return new createjs.Bitmap(item);
	}
	,getImage: function(id) {
		return this._loadQueue.getResult(id);
	}
	,getResult: function(id) {
		return this._loadQueue.getResult(id);
	}
	,onAudioLoaded: function() {
		this._audioLoaded = true;
		this.checkForCompletion();
	}
	,loadManifest: function(manifest) {
		if(manifest.length > 0) {
			this._loadQueue.addEventListener("complete",$bind(this,this.onQueueComplete),null);
			this._loadQueue.loadManifest(manifest);
		} else {
			this._imagesLoaded = true;
			this.checkForCompletion();
		}
	}
	,loadPostManifest: function(manifest) {
		this._loadQueue.loadManifest(manifest);
	}
	,onQueueComplete: function(event) {
		this._loadQueue.removeEventListener("complete",$bind(this,this.onQueueComplete),null);
		this._imagesLoaded = true;
		this.checkForCompletion();
	}
	,checkForCompletion: function() {
		if(this._audioLoaded && this._imagesLoaded && !this.completed) {
			this.completed = true;
			this._completeCallback();
		}
	}
	,__class__: sg_pbskids_AssetPackage
};
var sg_pbskids_audio_SRAudioManager = function(voPlayer,sound) {
	this._callbacks = new haxe_ds_StringMap();
	this._soundMap = new haxe_ds_StringMap();
	this._sounds = new haxe_ds_StringMap();
	createjs.EventDispatcher.call(this);
	this._voPlayer = voPlayer;
	this._sound = sound;
};
sg_pbskids_audio_SRAudioManager.__name__ = ["sg","pbskids","audio","SRAudioManager"];
sg_pbskids_audio_SRAudioManager.init = function(springrollApp) {
	if(sg_pbskids_audio_SRAudioManager.instance != null) return;
	sg_pbskids_audio_SRAudioManager.instance = new sg_pbskids_audio_SRAudioManager(springrollApp.voPlayer,springrollApp.sound);
};
sg_pbskids_audio_SRAudioManager.__super__ = createjs.EventDispatcher;
sg_pbskids_audio_SRAudioManager.prototype = $extend(createjs.EventDispatcher.prototype,{
	playAudio: function(id,callback) {
		var soundInstance = this._sound.play(id,callback);
		return soundInstance;
	}
	,loopAudio: function(id) {
		var options = { 'loop' : -1};
		var soundInstance = this._sound.play(id,options);
		return soundInstance;
	}
	,playVO: function(id,callback,allowInterrupt) {
		if(allowInterrupt == null) allowInterrupt = true;
		if(allowInterrupt || !this._voPlayer.playing) {
			this._voCallback = null;
			this._voPlayer.play(id,callback);
		} else window.console.log("VO dropped due to conflicting VO playing. " + id + " --/-> " + this._voPlayer.currentVO);
	}
	,get_isVOPlaying: function() {
		return this._voPlayer.playing;
	}
	,stopAudio: function(id) {
		this._sound.stop(id);
	}
	,stopVO: function(id) {
		this._voPlayer.stop();
	}
	,killAll: function() {
		this._voPlayer.stop();
		this._sound.stopAll();
	}
	,handleFailed: function(e) {
	}
	,handleComplete: function(e) {
		if((function($this) {
			var $r;
			var key = e.currentTarget.uniqueId;
			$r = $this._callbacks.get(key);
			return $r;
		}(this)) != null) ((function($this) {
			var $r;
			var key1 = e.currentTarget.uniqueId;
			$r = $this._callbacks.get(key1);
			return $r;
		}(this)))();
		((function($this) {
			var $r;
			var key2 = e.currentTarget.uniqueId;
			$r = $this._sounds.get(key2);
			return $r;
		}(this))).stop();
		((function($this) {
			var $r;
			var key3 = e.currentTarget.uniqueId;
			$r = $this._sounds.get(key3);
			return $r;
		}(this))).removeEventListener("complete",$bind(this,this.handleComplete));
		((function($this) {
			var $r;
			var key4 = e.currentTarget.uniqueId;
			$r = $this._sounds.get(key4);
			return $r;
		}(this))).removeEventListener("failed",$bind(this,this.handleFailed));
		var k = e.currentTarget.uniqueId;
		this._sounds.set(k,null);
		null;
		var key5 = e.currentTarget.uniqueId;
		this._sounds.remove(key5);
		var k1 = e.currentTarget.uniqueId;
		this._callbacks.set(k1,null);
		null;
		var key6 = e.currentTarget.uniqueId;
		this._callbacks.remove(key6);
	}
	,loadAudio: function(manifest,loadedCallback) {
		var aliases = [];
		var _g = 0;
		while(_g < manifest.length) {
			var obj = manifest[_g];
			++_g;
			aliases.push(obj.id);
		}
		this._sound.preload(aliases,loadedCallback);
	}
	,queueLoaded: function(e) {
	}
	,__class__: sg_pbskids_audio_SRAudioManager
});
var sg_springroll_logging_Logging = function() { };
sg_springroll_logging_Logging.__name__ = ["sg","springroll","logging","Logging"];
sg_springroll_logging_Logging.log = function(args,caller) {
	if(sg_springroll_logging_Logging.enabled) {
		if(caller != null) args = sg_springroll_logging_Logging.getCallerString(caller) + Std.string(args);
		springroll.Debug.log(args);
	}
};
sg_springroll_logging_Logging.getCallerString = function(caller) {
	if(caller == null) return "";
	var parts = Type.getClassName(caller).split(".");
	return "[" + parts[parts.length - 1] + "] ";
};
sg_springroll_logging_Logging.clear = function() {
	if(sg_springroll_logging_Logging.enabled) springroll.Debug.clear();
};
sg_springroll_logging_Logging.debug = function(args,caller) {
	if(sg_springroll_logging_Logging.enabled) {
		if(caller != null) args = sg_springroll_logging_Logging.getCallerString(caller) + Std.string(args);
		springroll.Debug.debug(args);
	}
};
sg_springroll_logging_Logging.error = function(args,caller) {
	if(sg_springroll_logging_Logging.enabled) {
		if(caller != null) args = sg_springroll_logging_Logging.getCallerString(caller) + Std.string(args);
		springroll.Debug.error(args);
	}
};
sg_springroll_logging_Logging.info = function(args,caller) {
	if(sg_springroll_logging_Logging.enabled) {
		if(caller != null) args = sg_springroll_logging_Logging.getCallerString(caller) + Std.string(args);
		springroll.Debug.info(args);
	}
};
sg_springroll_logging_Logging.trace = function(args,caller) {
	if(sg_springroll_logging_Logging.enabled) {
		if(caller != null) args = sg_springroll_logging_Logging.getCallerString(caller) + Std.string(args);
		springroll.Debug.trace(args);
	}
};
sg_springroll_logging_Logging.aqua = function(args,caller) {
	if(sg_springroll_logging_Logging.enabled) {
		if(caller != null) args = sg_springroll_logging_Logging.getCallerString(caller) + Std.string(args);
		springroll.Debug.aqua(args);
	}
};
sg_springroll_logging_Logging.blue = function(args,caller) {
	if(sg_springroll_logging_Logging.enabled) {
		if(caller != null) args = sg_springroll_logging_Logging.getCallerString(caller) + Std.string(args);
		springroll.Debug.blue(args);
	}
};
sg_springroll_logging_Logging.gray = function(args,caller) {
	if(sg_springroll_logging_Logging.enabled) {
		if(caller != null) args = sg_springroll_logging_Logging.getCallerString(caller) + Std.string(args);
		springroll.Debug.gray(args);
	}
};
sg_springroll_logging_Logging.green = function(args,caller) {
	if(sg_springroll_logging_Logging.enabled) {
		if(caller != null) args = sg_springroll_logging_Logging.getCallerString(caller) + Std.string(args);
		springroll.Debug.green(args);
	}
};
sg_springroll_logging_Logging.lime = function(args,caller) {
	if(sg_springroll_logging_Logging.enabled) {
		if(caller != null) args = sg_springroll_logging_Logging.getCallerString(caller) + Std.string(args);
		springroll.Debug.lime(args);
	}
};
sg_springroll_logging_Logging.maroon = function(args,caller) {
	if(sg_springroll_logging_Logging.enabled) {
		if(caller != null) args = sg_springroll_logging_Logging.getCallerString(caller) + Std.string(args);
		springroll.Debug.maroon(args);
	}
};
sg_springroll_logging_Logging.navy = function(args,caller) {
	if(sg_springroll_logging_Logging.enabled) {
		if(caller != null) args = sg_springroll_logging_Logging.getCallerString(caller) + Std.string(args);
		springroll.Debug.navy(args);
	}
};
sg_springroll_logging_Logging.olive = function(args,caller) {
	if(sg_springroll_logging_Logging.enabled) {
		if(caller != null) args = sg_springroll_logging_Logging.getCallerString(caller) + Std.string(args);
		springroll.Debug.olive(args);
	}
};
sg_springroll_logging_Logging.orange = function(args,caller) {
	if(sg_springroll_logging_Logging.enabled) {
		if(caller != null) args = sg_springroll_logging_Logging.getCallerString(caller) + Std.string(args);
		springroll.Debug.orange(args);
	}
};
sg_springroll_logging_Logging.pink = function(args,caller) {
	if(sg_springroll_logging_Logging.enabled) {
		if(caller != null) args = sg_springroll_logging_Logging.getCallerString(caller) + Std.string(args);
		springroll.Debug.pink(args);
	}
};
sg_springroll_logging_Logging.purple = function(args,caller) {
	if(sg_springroll_logging_Logging.enabled) {
		if(caller != null) args = sg_springroll_logging_Logging.getCallerString(caller) + Std.string(args);
		springroll.Debug.purple(args);
	}
};
sg_springroll_logging_Logging.red = function(args,caller) {
	if(sg_springroll_logging_Logging.enabled) {
		if(caller != null) args = sg_springroll_logging_Logging.getCallerString(caller) + Std.string(args);
		springroll.Debug.red(args);
	}
};
sg_springroll_logging_Logging.silver = function(args,caller) {
	if(sg_springroll_logging_Logging.enabled) {
		if(caller != null) args = sg_springroll_logging_Logging.getCallerString(caller) + Std.string(args);
		springroll.Debug.silver(args);
	}
};
sg_springroll_logging_Logging.teal = function(args,caller) {
	if(sg_springroll_logging_Logging.enabled) {
		if(caller != null) args = sg_springroll_logging_Logging.getCallerString(caller) + Std.string(args);
		springroll.Debug.teal(args);
	}
};
sg_springroll_logging_Logging.yellow = function(args,caller) {
	if(sg_springroll_logging_Logging.enabled) {
		if(caller != null) args = sg_springroll_logging_Logging.getCallerString(caller) + Std.string(args);
		springroll.Debug.yellow(args);
	}
};
var sg_springroll_screens_TitleScreen = function(dataDef,startScene,readyCallback) {
	sg_cjs_GameScreen.call(this);
	this._startScene = startScene;
	this._readyCallback = readyCallback;
	this._data = dataDef;
	this._assets = new sg_pbskids_AssetPackage(this._data.manifestData.assetManifest,this._data.manifestData.audioManifest,$bind(this,this.onPackageReady));
	this._assets.load();
};
sg_springroll_screens_TitleScreen.__name__ = ["sg","springroll","screens","TitleScreen"];
sg_springroll_screens_TitleScreen.__super__ = sg_cjs_GameScreen;
sg_springroll_screens_TitleScreen.prototype = $extend(sg_cjs_GameScreen.prototype,{
	destroy: function() {
		createjs.Tween.removeTweens(this);
		this._bg = null;
		this._playButton.removeAllEventListeners();
		this._playButton.destroy();
		this._playButton = null;
		window.removeEventListener("keydown",$bind(this,this.onKeyDown));
		sg_pbskids_audio_SRAudioManager.instance.killAll();
	}
	,start: function() {
		if(this._data.audio != null) createjs.Tween.get(this).wait(1500,true).call(($_=sg_pbskids_audio_SRAudioManager.instance,$bind($_,$_.playVO)),[this._data.audio]);
	}
	,onPackageReady: function() {
		this._bg = this._assets.getBitmap(this._data.image);
		this.addChild(this._bg);
		this._playButton = new sg_cjs_ui_HoverButton(this._assets.getSpriteFromSheet(this._data.playButton.art.up,this._data.playButton.art.sheet),this._assets.getSpriteFromSheet(this._data.playButton.art.down,this._data.playButton.art.sheet));
		this.addChild(this._playButton);
		if(this._data.playButton.align == "center") {
			this._playButton.x = sg_pbskids_daniel_SpringrollGame.SpringrollApp.display.width * this._data.playButton.position.x - this._playButton.getBounds().width * 0.5;
			this._playButton.y = sg_pbskids_daniel_SpringrollGame.SpringrollApp.display.height * this._data.playButton.position.y - this._playButton.getBounds().height * 0.5;
		}
		this._playButton.turnOn();
		this._playButton.addEventListener("down",$bind(this,this.triggerAdvance));
		this.addEventListener("mousedown",$bind(this,this.triggerAdvance),null);
		window.addEventListener("keydown",$bind(this,this.onKeyDown));
		this._readyCallback();
	}
	,onKeyDown: function(e) {
		window.removeEventListener("keydown",$bind(this,this.onKeyDown));
		this.triggerAdvance();
	}
	,triggerAdvance: function(e) {
		this.removeEventListener("mousedown",$bind(this,this.triggerAdvance),null);
		window.removeEventListener("keydown",$bind(this,this.onKeyDown));
		this._playButton.removeEventListener("down",$bind(this,this.triggerAdvance));
		this._playButton.turnOff();
		createjs.Tween.removeTweens(this);
		sg_pbskids_audio_SRAudioManager.instance.killAll();
		this.dispatchEvent(new sg_cjs_SceneLoadEvent("sceneRequest",this._startScene));
	}
	,__class__: sg_springroll_screens_TitleScreen
});
var $_, $fid = 0;
function $bind(o,m) { if( m == null ) return null; if( m.__id__ == null ) m.__id__ = $fid++; var f; if( o.hx__closures__ == null ) o.hx__closures__ = {}; else f = o.hx__closures__[m.__id__]; if( f == null ) { f = function(){ return f.method.apply(f.scope, arguments); }; f.scope = o; f.method = m; o.hx__closures__[m.__id__] = f; } return f; }
String.prototype.__class__ = String;
String.__name__ = ["String"];
Array.__name__ = ["Array"];
var Int = { __name__ : ["Int"]};
var Dynamic = { __name__ : ["Dynamic"]};
var Float = Number;
Float.__name__ = ["Float"];
var Bool = Boolean;
Bool.__ename__ = ["Bool"];
var Class = { __name__ : ["Class"]};
var Enum = { };
createjs.DisplayObject.prototype.setBounds = function(x, y, width, height) { this._bounds = x != null ? (this._bounds || new createjs.Rectangle()).setValues(x, y, width, height) : null; };;
var __map_reserved = {}
js_Boot.__toStr = {}.toString;
pbsdaniel_Constants.GAME_WIDTH = 960;
pbsdaniel_Constants.GAME_HEIGHT = 500;
pbsdaniel_Constants.GAME_NAME = "DressUp";
pbsdaniel_Constants.CHAR_CHRISSIE = "Chrissie";
pbsdaniel_Constants.CHAR_DANIEL = "Daniel";
pbsdaniel_Constants.CHAR_ELAINA = "Elaina";
pbsdaniel_Constants.CHAR_KATERINA = "Katerina";
pbsdaniel_Constants.CHAR_O = "O";
pbsdaniel_Constants.CHAR_WEDNESDAY = "Wednesday";
pbsdaniel_Constants.GAME_DATA = "gameData";
pbsdaniel_Constants.GLOBAL_ASSETS = "globalAssets";
pbsdaniel_Constants.CHARACTER_DATA = "characterData";
pbsdaniel_Constants.TITLESCREEN_DATA = "titlescreenData";
pbsdaniel_Constants.TRANSITION_IMG = "transitionImg";
pbsdaniel_Constants.DRESSUP_SCENE = "dressupScene";
pbsdaniel_Constants.ITEM_HAT = "hat";
pbsdaniel_DTLoadingScreen.DT_LOADING_SS = "loadingScreenSheet";
pbsdaniel_dressup_Curtain.CLOSED = "curtainClosed";
pbsdaniel_dressup_DressUp.CURTAIN = "curtain";
pbsdaniel_dressup_DressUp.IntroSeen = false;
pbsdaniel_dressup_DressUp.ChangedCharacter = false;
sg_cjs_GameScreen.COMPLETE = "complete";
pbsdaniel_dressup_DressupCharacter.IDLE = "stateIdle";
pbsdaniel_dressup_DressupCharacter.INTRO = "stateIntro";
pbsdaniel_dressup_DressupCharacter.REACTING = "stateReacting";
pbsdaniel_dressup_DressupCharacter.FRIEND = "stateFriend";
pbsdaniel_dressup_DressupCharacter.ARM_SWAP_HAT = "hat_swap";
pbsdaniel_dressup_DressupCharacter.ARM_SWAP_TORSO = "torso_swap";
pbsdaniel_dressup_DressupCharacter.ARM_SWAP_LARM = "left_arm_swap";
pbsdaniel_dressup_DressupCharacter.ARM_SWAP_RARM = "right_arm_swap";
pbsdaniel_dressup_DressupCharacter.ARM_SWAP_LLEG = "left_leg_swap";
pbsdaniel_dressup_DressupCharacter.ARM_SWAP_RLEG = "right_leg_swap";
pbsdaniel_dressup_DressupCharacter.ARM_SWAP_CAPE = "cape_swap";
pbsdaniel_dressup_DressupCharacter.ARM_SWAP_LSHOE = "left_shoe_swap";
pbsdaniel_dressup_DressupCharacter.ARM_SWAP_RSHOE = "right_shoe_swap";
pbsdaniel_dressup_DressupCharacter.ARM_SWAP_LBOOT = "left_boot_swap";
pbsdaniel_dressup_DressupCharacter.ARM_SWAP_RBOOT = "right_boot_swap";
pbsdaniel_dressup_DressupCharacter.ARM_SWAP_FACE = "head_accessory_swap";
pbsdaniel_dressup_DressupCharacter.ARM_SWAP_BACK = "back_accessory_swap";
pbsdaniel_dressup_DressupCharacter.ARM_SWAP_CHEST = "accessory_swap";
pbsdaniel_dressup_DressupCharacter.SLOT_FACE = "face";
pbsdaniel_dressup_DressupCharacter.SLOT_CHEST = "chest";
pbsdaniel_dressup_DressupCharacter.SLOT_BACK = "back";
pbsdaniel_dressup_DressupCharacter.PAYOFF = "payoff";
pbsdaniel_dressup_DressupIcon.HAT = "hat";
pbsdaniel_dressup_DressupIcon.TORSO = "body";
pbsdaniel_dressup_DressupIcon.SHOES = "feet";
pbsdaniel_dressup_DressupIcon.ACCESSORY = "accessory";
pbsdaniel_dressup_DressupIcon.ACCESSORY_FACE = "accessory_face";
pbsdaniel_dressup_DressupIcon.ACCESSORY_CHEST = "accessory_chest";
pbsdaniel_dressup_DressupIcon.ACCESSORY_BACK = "accessory_back";
sg_cjs_SceneLoadEvent.SCENE_REQUEST = "sceneRequest";
sg_cjs_SceneLoadEvent.GAME_RESTART = "gameRestart";
sg_cjs_ui_HoverButton.ACTIVATED = "activated";
sg_cjs_ui_HoverButton.DOWN = "down";
sg_cjs_ui_HoverButton.OVER = "over";
sg_cjs_views_LoadingAnimation.SPRITESHEET = "loadingSpriteSheet";
sg_cjs_views_LoadingAnimation.DATA = "loadingData";
sg_cjs_views_LoadingScreen.READY = "ready";
sg_springroll_logging_Logging.enabled = true;
sg_springroll_screens_TitleScreen.TITLE_SCREEN_SS = "titleScreenSS";
pbsdaniel_dressup_Main.main();
})(typeof console != "undefined" ? console : {log:function(){}}, typeof window != "undefined" ? window : typeof global != "undefined" ? global : typeof self != "undefined" ? self : this);

//# sourceMappingURL=haxe.js.map