(function(){

	// Library depencencies
	var Application = include('springroll.Application'),
		Display = include('springroll.easeljs.EaselJSDisplay');

	// Create a new application
	var app = new Application({
		fps: 60,
		name: "dress-up",
		canvasId: "stage",
		configPath: 'assets/config/config.json',		
		captionsPath: 'assets/config/captions.json',
		display: Display
	});

	var _currentScene;
	var _bellhop = new Bellhop();
	_bellhop.connect();
	
	// Handle when app is ready to use
	app.on('init', function()
	{
		window.SGGameButler.startGame(app, _bellhop);
	});

	// Assign to the window for easy access
	//window.app = app;
	
	console.log("Setup complete!");
	
}());
//# sourceMappingURL=main.js.map